import AbstractGraphQLSourceCodeGenerator from "./AbstractGraphQLSourceCodeGenerator";
import { sdk_definition, sdk_definition_files, sdk_service_definition, sdk_service_definition_method_arg, sdk_service_definition_type, sdk_service_definition_type_field, sdk_service_type } from "./types";
import { GraphQLEnumType, GraphQLInputObjectType, GraphQLObjectType, GraphQLScalarType, GraphQLType } from "graphql";
export declare abstract class AbstractTypescriptSdkGraphQLSourceCodeGenerator extends AbstractGraphQLSourceCodeGenerator {
    protected configureSdkDefinition(def: sdk_definition): Promise<void>;
    protected buildDynamicFiles(): Promise<sdk_definition_files>;
    protected buildVars(): Promise<{
        [key: string]: any;
    }>;
    protected buildDefaultVars(): Promise<{
        [key: string]: any;
    }>;
    protected buildPackageJsonModel({ packageName, packageVersion, packageDescription, repository, publishConfig, dependencies, peerDependencies, devDependencies }: any): Promise<any>;
    protected buildStaticFilesFromStaticTemplates(): Promise<{
        [key: string]: string | true;
    }>;
    protected buildSdkServiceDefinition(): Promise<sdk_service_definition>;
    protected buildSdkServiceDefinitionTypes(def: sdk_service_definition): Promise<void>;
    protected buildSdkServiceDefinitionModels(def: sdk_service_definition): Promise<void>;
    protected buildSdkServiceDefinitionInputs(def: sdk_service_definition): Promise<void>;
    protected buildSdkServiceDefinitionQueries(def: sdk_service_definition): Promise<void>;
    protected buildSdkServiceDefinitionQueryQueries(def: sdk_service_definition): Promise<void>;
    protected buildSdkServiceDefinitionMutationQueries(def: sdk_service_definition): Promise<void>;
    protected sortObject(o: any): {};
    protected convertGraphQLTypeToField(type: GraphQLType): Omit<sdk_service_definition_type_field, 'name'>;
    protected convertGraphQLTypeToArg(type: GraphQLType): Omit<sdk_service_definition_method_arg, 'name'>;
    protected convertGraphQLTypeToReturnType(type: GraphQLType): Omit<sdk_service_definition_method_arg, 'name'>;
    protected convertGraphQLTypeToType(type: GraphQLType): Omit<sdk_service_definition_type, 'name'>;
    protected convertGraphQLType(type: GraphQLType): sdk_service_type;
    buildPrimitiveTypeMapping(type: GraphQLScalarType): sdk_service_type;
    buildEnumTypeMapping(type: GraphQLEnumType): sdk_service_type;
    buildObjectTypeMapping(type: GraphQLObjectType): sdk_service_type;
    buildInputObjectTypeMapping(type: GraphQLInputObjectType): sdk_service_type;
}
export default AbstractTypescriptSdkGraphQLSourceCodeGenerator;
//# sourceMappingURL=AbstractTypescriptSdkGraphQLSourceCodeGenerator.d.ts.map